#include <stdio.h>
#include "mytime.h"

#define CONST (1000)


unsigned long long get_cycles() {
	unsigned int lo, hi;
	asm volatile (
		"\tcpuid\n"
		"\trdtsc\n"
		: "=a"(lo), "=d"(hi) /* outputs =a/=d means use eax/edx*/
   		:                    /* inputs (no inputs) */
   		: "%ebx", "%ecx"     /* clobbers*/

	);
	unsigned long long ret_val = ((unsigned long long)hi) << 32 | lo;
	return ret_val;
}


int n = CONST;
double  A[CONST][CONST];
double  B[CONST][CONST];
double  C[CONST][CONST];

void mmijk(){
    int i,j,k;
    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++) {
            double sum = 0.0;
            for (k = 0; k < n; k++)
                sum += A[i][k]*B[k][j];
            C[i][j] += sum;
        }
}

void mmjik(){
    int i,j,k;
    for (j = 0; j < n; j++)
        for (i = 0; i < n; i++) {
            double sum = 0.0;
            for (k = 0; k < n; k++)
                sum += A[i][k]*B[k][j];
            C[i][j] += sum;
        }
}



void mmjki(){
    int i,j,k;
    for (j = 0; j < n; j++)
        for (k = 0; k < n; k++) {
            double r;
            r = B[k][j];
            for (i = 0; i < n; i++)
                C[i][j] += A[i][k]*r;
        }
}

void mmkji(){
    int i,j,k;
    for (k = 0; k < n; k++)
        for (j = 0; j < n; j++) {
            double r;
            r = B[k][j];
            for (i = 0; i < n; i++)
                C[i][j] += A[i][k]*r;
        }
}


void mmkij(){
    int i,j,k;
    for (k = 0; k < n; k++)
        for (i = 0; i < n; i++) {
            double r;
            r = A[i][k];
            for (j = 0; j < n; j++)
                C[i][j] += r*B[k][j];
        }
}

void mmikj(){
    int i,j,k;
    for (i = 0; i < n; i++)
        for (k = 0; k < n; k++) {
            double r;
            r = A[i][k];
            for (j = 0; j < n; j++)
                C[i][j] += r*B[k][j];
        }
}

int main() {

    void(*f[6])()  = {mmijk, mmjik,  mmjki, mmkji, mmkij, mmikj};
    char* fnames[6]  = {"mmijk", "mmjik", "mmjki", "mmkji",  "mmkij", "mmikj"};

    for(int i=0;i<6;i++){ 
        double t1 = Time_GetSeconds();
        long long c1 = get_cycles();
        (*f[i])();
        long long c2 = get_cycles();
        double t2 = Time_GetSeconds();
        printf("Time taken for %s is : %lld cycles or  %0.2f seconds \n", fnames[i], c2-c1,  t2-t1);
    }
   
    return 0;
}
